package com.example.demo;

import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/types")
public class TypeController {
    private final Logger log = LoggerFactory.getLogger(TypeController.class);
    private List<Type> types = new ArrayList<Type>();

    // Получение всех жанров
    @GetMapping
    public List<Type> getTypes() {
        return types;
    }

    // Получение 1 жанра по id
    @GetMapping("/{id}")
    public Type getType(@PathVariable(name = "id") int id) {
        return types.get(id);
    }

    // Добавление жанра
    @PostMapping
    public Type addType(@RequestBody Type type) {
        types.add(type);
        return type;
    }

    @PutMapping("/{id}")
    public Type updateType(@PathVariable(name = "id") int id, @RequestBody Type type) {
        types.remove(id);
        types.add(id, type);
        return type;
    }

    @DeleteMapping("/{id}")
    public Type deleteType(@PathVariable(name = "id") int id) {
        // Удаляемая игра по id
        Type deletedType = types.get(id);
        types.remove(deletedType);
        return deletedType;
    }
}
